/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-05-14 03:07:32 UTC)
 * on 2013-05-17 at 16:42:51 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

/**
 * JSON template for Member resource in Apps Directory API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Apps Directory API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Member extends com.google.api.client.json.GenericJson {

  /**
   * Email of member
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String email;

  /**
   * Unique identifier of group (Read-only) Unique identifier of member (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * Kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Role of member
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String role;

  /**
   * Type of member (Immutable)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * Email of member
   * @return value or {@code null} for none
   */
  public java.lang.String getEmail() {
    return email;
  }

  /**
   * Email of member
   * @param email email or {@code null} for none
   */
  public Member setEmail(java.lang.String email) {
    this.email = email;
    return this;
  }

  /**
   * Unique identifier of group (Read-only) Unique identifier of member (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Unique identifier of group (Read-only) Unique identifier of member (Read-only)
   * @param id id or {@code null} for none
   */
  public Member setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * Kind of resource this is.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is.
   * @param kind kind or {@code null} for none
   */
  public Member setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Role of member
   * @return value or {@code null} for none
   */
  public java.lang.String getRole() {
    return role;
  }

  /**
   * Role of member
   * @param role role or {@code null} for none
   */
  public Member setRole(java.lang.String role) {
    this.role = role;
    return this;
  }

  /**
   * Type of member (Immutable)
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * Type of member (Immutable)
   * @param type type or {@code null} for none
   */
  public Member setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  @Override
  public Member set(String fieldName, Object value) {
    return (Member) super.set(fieldName, value);
  }

  @Override
  public Member clone() {
    return (Member) super.clone();
  }

}
