/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-05-14 03:07:32 UTC)
 * on 2013-05-17 at 16:42:51 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

/**
 * JSON template for Photo object in Apps Directory API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Apps Directory API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UserPhoto extends com.google.api.client.json.GenericJson {

  /**
   * Height in pixels of the photo
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer height;

  /**
   * Unique identifier of User (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * Kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Mime Type of the photo
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String mimeType;

  /**
   * Base64 encoded photo data
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String photoData;

  /**
   * Primary email of User (Read-only)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String primaryEmail;

  /**
   * Width in pixels of the photo
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer width;

  /**
   * Height in pixels of the photo
   * @return value or {@code null} for none
   */
  public java.lang.Integer getHeight() {
    return height;
  }

  /**
   * Height in pixels of the photo
   * @param height height or {@code null} for none
   */
  public UserPhoto setHeight(java.lang.Integer height) {
    this.height = height;
    return this;
  }

  /**
   * Unique identifier of User (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Unique identifier of User (Read-only)
   * @param id id or {@code null} for none
   */
  public UserPhoto setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * Kind of resource this is.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is.
   * @param kind kind or {@code null} for none
   */
  public UserPhoto setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Mime Type of the photo
   * @return value or {@code null} for none
   */
  public java.lang.String getMimeType() {
    return mimeType;
  }

  /**
   * Mime Type of the photo
   * @param mimeType mimeType or {@code null} for none
   */
  public UserPhoto setMimeType(java.lang.String mimeType) {
    this.mimeType = mimeType;
    return this;
  }

  /**
   * Base64 encoded photo data
   * @see #decodePhotoData()
   * @return value or {@code null} for none
   */
  public java.lang.String getPhotoData() {
    return photoData;
  }

  /**
   * Base64 encoded photo data
   * @see #getPhotoData()
   * @return Base64 decoded value or {@code null} for none
   *
   * @since 1.14
   */
  public byte[] decodePhotoData() {
    return com.google.api.client.util.Base64.decodeBase64(photoData);
  }

  /**
   * Base64 encoded photo data
   * @see #encodePhotoData()
   * @param photoData photoData or {@code null} for none
   */
  public UserPhoto setPhotoData(java.lang.String photoData) {
    this.photoData = photoData;
    return this;
  }

  /**
   * Base64 encoded photo data
   * @see #setPhotoData()
   *
   * <p>
   * The value is encoded Base64 or {@code null} for none.
   * </p>
   *
   * @since 1.14
   */
  public UserPhoto encodePhotoData(byte[] photoData) {
    this.photoData = com.google.api.client.util.Base64.encodeBase64URLSafeString(photoData);
    return this;
  }

  /**
   * Primary email of User (Read-only)
   * @return value or {@code null} for none
   */
  public java.lang.String getPrimaryEmail() {
    return primaryEmail;
  }

  /**
   * Primary email of User (Read-only)
   * @param primaryEmail primaryEmail or {@code null} for none
   */
  public UserPhoto setPrimaryEmail(java.lang.String primaryEmail) {
    this.primaryEmail = primaryEmail;
    return this;
  }

  /**
   * Width in pixels of the photo
   * @return value or {@code null} for none
   */
  public java.lang.Integer getWidth() {
    return width;
  }

  /**
   * Width in pixels of the photo
   * @param width width or {@code null} for none
   */
  public UserPhoto setWidth(java.lang.Integer width) {
    this.width = width;
    return this;
  }

  @Override
  public UserPhoto set(String fieldName, Object value) {
    return (UserPhoto) super.set(fieldName, value);
  }

  @Override
  public UserPhoto clone() {
    return (UserPhoto) super.clone();
  }

}
