/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-05-14 03:07:32 UTC)
 * on 2013-05-17 at 16:42:51 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.admin.directory.model;

/**
 * JSON response template for List Users operation in Apps Directory API.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Apps Directory API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Users extends com.google.api.client.json.GenericJson {

  /**
   * Kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Token used to access next page of this result.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * Event that triggered this response (only used in case of Push Response)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("trigger_event")
  private java.lang.String triggerEvent;

  /**
   * List of user objects.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<User> users;

  static {
    // hack to force ProGuard to consider User used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(User.class);
  }

  /**
   * Kind of resource this is.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is.
   * @param kind kind or {@code null} for none
   */
  public Users setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Token used to access next page of this result.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * Token used to access next page of this result.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  public Users setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  /**
   * Event that triggered this response (only used in case of Push Response)
   * @return value or {@code null} for none
   */
  public java.lang.String getTriggerEvent() {
    return triggerEvent;
  }

  /**
   * Event that triggered this response (only used in case of Push Response)
   * @param triggerEvent triggerEvent or {@code null} for none
   */
  public Users setTriggerEvent(java.lang.String triggerEvent) {
    this.triggerEvent = triggerEvent;
    return this;
  }

  /**
   * List of user objects.
   * @return value or {@code null} for none
   */
  public java.util.List<User> getUsers() {
    return users;
  }

  /**
   * List of user objects.
   * @param users users or {@code null} for none
   */
  public Users setUsers(java.util.List<User> users) {
    this.users = users;
    return this;
  }

  @Override
  public Users set(String fieldName, Object value) {
    return (Users) super.set(fieldName, value);
  }

  @Override
  public Users clone() {
    return (Users) super.clone();
  }

}
